/*1a*/
USE [Northwind2003-mini] 
DECLARE @country varchar(10) = 'USA';
DECLARE @date1 date = '10/1/1996';
DECLARE @date2 date = '12/1/1996';

SELECT * FROM orders where ShipCountry=@country and OrderDate between @date1 and @date2;


/*1b*/

DECLARE @count int;
SELECT @count=COUNT(*) FROM Customers;
SELECT @count=@count+COUNT(*) FROM Suppliers; 
SELECT @count=@count+COUNT(*) FROM Employees; 

Print 'Total number of people to invite: '+Convert(char,@count);

/*2a*/
declare @year int = 2100;

if @year%4=0
begin
	if @year/400<>0 AND @year/100=0
		print 'Not Leap';
	else
		print 'Leap';
end
else
	print 'Not leap';
	
/*2b*/
declare @fn varchar(20) = 'Jack';
declare @ln varchar(20) = 'Zheng';

if exists (select * from Employees where FirstName=@fn and LastName=@ln)
	select * from Employees where FirstName=@fn and LastName=@ln
else
begin
	declare @eid int = (select top 1 employeeid from Employees order by EmployeeID desc);
	set @eid=@eid+1;
	insert into Employees (employeeid, FirstName, LastName) values (@eid, @fn, @ln);
end

/*2c*/
DECLARE @max INT = 10;
DECLARE @min INT = 6;
DECLARE @step INT = @min;
DECLARE @result INT = 0;

WHILE @step <= @max
BEGIN
	SET @result=@result+@step;
	SET @step = @step + 1;
END

select @result as result


/*3a*/
select	year(OrderDate) year, q=
	case
		when MONTH(OrderDate) in (1,2,3) then 'Q1'
		when MONTH(OrderDate) in (4,5,6) then 'Q2'
		when MONTH(OrderDate) in (7,8,9) then 'Q3'
		else 'Q4'
	end,
	orderid
	from Orders
	
/*3b*/
with ord as
(
	select	year(OrderDate) year, q=
	case
		when MONTH(OrderDate) in (1,2,3) then 'Q1'
		when MONTH(OrderDate) in (4,5,6) then 'Q2'
		when MONTH(OrderDate) in (7,8,9) then 'Q3'
		else 'Q4'
	end,
	orderid
	from Orders
)
select year, q, COUNT(OrderID) from ord
group by year, q
order by year, q

/*3c*/

declare @factor int=2;
declare @cat int=3;
select * from products
where UnitsInStock+UnitsOnOrder<
case CategoryID
	when @cat then ReorderLevel*@factor
	else ReorderLevel
end

/*4a*/
CREATE PROC OrderQuery 
	@country varchar(10) = 'USA',
	@date1 date = '10/1/1996',
	@date2 date = '12/1/1996'
AS
BEGIN

SELECT * FROM orders 
where ShipCountry=@country and OrderDate between @date1 and @date2;

END
GO

/*4b*/

CREATE PROC EmployeeQuery 
	@fn varchar(20),
	@ln varchar(20)
AS
BEGIN

if exists (select * from Employees where FirstName=@fn and LastName=@ln)
	select * from Employees where FirstName=@fn and LastName=@ln
else
begin
	declare @eid int = (select top 1 employeeid from Employees order by EmployeeID desc);
	set @eid=@eid+1;
	insert into Employees (employeeid, FirstName, LastName) values (@eid, @fn, @ln);
	print @fn+' '+@ln+' ('+convert(varchar, @eid)+') is a new employee and now is inserted in the table.'
end

END
GO

/*4c*/
CREATE FUNCTION IsLeapYear(@year int)
RETURNS bit
AS
BEGIN
	declare @isLeap bit;
	
	if @year%4=0
	begin
		if @year/100=0 AND @year/400<>0
			set @isLeap=0;
		else
			set @isLeap=1;
	end
	else
		set @isLeap=0;
		
	return @isLeap;
END
